## xdelta3-gui 0.23.10.01

=== debian/changelog ===
xdelta3-gui (0.23.10.01) mx; urgency=medium

  * Change icon

 -- Adrian <adrian@mxlinux.org>  Mon, 30 Oct 2023 13:43:52 -0400

xdelta3-gui (0.23.10) mx; urgency=medium

  * Initial release

 -- Adrian <adrian@mxlinux.org>  Mon, 23 Oct 2023 02:00:02 -0400

## xdelta3-gui 23.12

=== debian/changelog ===
xdelta3-gui (23.12) mx; urgency=medium

  * New translations

 -- Adrian <adrian@mxlinux.org>  Sun, 10 Dec 2023 09:50:00 -0500

xdelta3-gui (0.23.10.02) mx; urgency=medium

  * Add svg icon

 -- Adrian <adrian@mxlinux.org>  Mon, 30 Oct 2023 18:13:17 -0400

## xdelta3-gui 26.01

=== CMakeLists.txt ===
# *****************************************************************************
# * Copyright (C) 2023 MX Authors
# *
# * Authors: Adrian <adrian@mxlinux.org>
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of xdelta3-gui.
# *
# * xdelta3-gui is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * xdelta3-gui is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with xdelta3-gui.  If not, see <http://www.gnu.org/licenses/>.
# *****************************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    # Fallback: parse changelog manually
    execute_process(
        COMMAND head -n 1 debian/changelog
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE FIRST_LINE
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    string(REGEX REPLACE ".*\\(([^)]+)\\).*" "\\1" PROJECT_VERSION_FROM_CHANGELOG "${FIRST_LINE}")
    if(NOT PROJECT_VERSION_FROM_CHANGELOG)
        message(FATAL_ERROR "Failed to parse version from debian/changelog")
    endif()
endif()

project(xdelta3-gui
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "xdelta3-gui - Graphical interface for xdelta3"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    main.cpp
    mainwindow.cpp
    cmd.cpp
)

set(HEADERS
    mainwindow.h
    cmd.h
)

set(UI_FILES
    mainwindow.ui
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(xdelta3-gui
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
)

# Link Qt6 libraries
target_link_libraries(xdelta3-gui
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(xdelta3-gui PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(xdelta3-gui PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(xdelta3-gui PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(xdelta3-gui PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    VERSION="${PROJECT_VERSION}"
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(xdelta3-gui PRIVATE NDEBUG)
    target_compile_options(xdelta3-gui PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(xdelta3-gui PRIVATE -flto=thin)
        target_link_options(xdelta3-gui PRIVATE -flto=thin)
    else()
        target_compile_options(xdelta3-gui PRIVATE -flto=auto)
        target_link_options(xdelta3-gui PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(xdelta3-gui
    TS_FILES ${TRANSLATION_FILES}
    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
    QM_FILES_OUTPUT_VARIABLE qm_files
)



# Set target properties
set_target_properties(xdelta3-gui PROPERTIES
    OUTPUT_NAME "xdelta3-gui"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)



# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS xdelta3-gui
    RUNTIME DESTINATION bin
)

## xdelta3-gui 24.3

=== debian/changelog ===
xdelta3-gui (24.3) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 12:41:52 -0400

=== debian/control ===
Source: xdelta3-gui
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8

Package: xdelta3-gui
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, xdelta3, progress
Description: xdelta3-gui
 GUI for xdelta3 application
 xdelta3 - VCDIFF (RFC 3284) binary diff tool

## xdelta3-gui 25.4

=== debian/changelog ===
xdelta3-gui (25.4) mx; urgency=medium

  * Update to Qt6
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 20:57:31 -0400

=== debian/control ===
Source: xdelta3-gui
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: https://github.com/mx-linux/xdelta3-gui
Homepage: https://mxlinux.org

Package: xdelta3-gui
Architecture: any
Depends: xdelta3,
         progress,
         xdg-utils | mx-viewer,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Graphical interface for xdelta3
 A user-friendly GUI for the xdelta3 application, which is a
 VCDIFF (RFC 3284) binary diff tool. This application allows users
 to create, apply, and manage binary patches through an intuitive
 interface. Designed for MX Linux, but may work on other systems.

## xdelta3-gui 26.01

=== debian/changelog ===
xdelta3-gui (26.01) mx; urgency=medium

  * Localize elapsed time display
  * Add guidelines and improve patch naming

 -- Adrian <adrian@mxlinux.org>  Sat, 03 Jan 2026 19:52:28 -0500

## xdelta3-gui 26.01.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -95,11 +95,13 @@
     main.cpp
     mainwindow.cpp
     cmd.cpp
+    droplineedit.cpp
 )
 
 set(HEADERS
     mainwindow.h
     cmd.h
+    droplineedit.h
 )
 
 set(UI_FILES
@@ -122,6 +124,9 @@
     Qt6::Gui
     Qt6::Widgets
 )
+
+# Include source directory for promoted widgets
+target_include_directories(xdelta3-gui PRIVATE ${CMAKE_SOURCE_DIR})
 
 # Set compiler flags
 target_compile_options(xdelta3-gui PRIVATE
@@ -184,3 +189,10 @@
 install(TARGETS xdelta3-gui
     RUNTIME DESTINATION bin
 )
+
+# Shared data for desktop integration and translations
+install(FILES xdelta3-gui.desktop DESTINATION share/applications)
+install(FILES xdelta3-gui.png DESTINATION share/pixmaps)
+install(FILES xdelta3-gui.svg DESTINATION share/icons/hicolor/scalable/apps)
+install(FILES x-xdelta3.xml DESTINATION share/mime/packages)
+install(FILES ${qm_files} DESTINATION share/xdelta3-gui/locale)

=== debian/changelog ===
xdelta3-gui (26.01.3) mx; urgency=medium

  * Handle final target patch naming
  * Default patch path to target directory
  * Show patch size on success

 -- Adrian <adrian@mxlinux.org>  Sat, 17 Jan 2026 14:17:03 -0500

xdelta3-gui (26.01.2) mx; urgency=medium

  * Enable drag and drop into the input fields
  * Refine patch name construction

 -- Adrian <adrian@mxlinux.org>  Sat, 17 Jan 2026 12:05:31 -0500

## xdelta3-gui 26.02

=== debian/changelog ===
xdelta3-gui (26.02) mx; urgency=medium

  * Improve patch creation/apply reliability for file paths with spaces and special characters
  * Fall back to a valid default compression option when the saved setting is unavailable
  * Make file pickers clearer with dedicated ISO/Delta filters and smoother directory selection
  * Correct user-facing wording in status and error messages
  * Improve default patch naming for version upgrades

 -- Adrian <adrian@mxlinux.org>  Sun, 15 Feb 2026 23:49:55 -0500

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: https://github.com/mx-linux/xdelta3-gui
 Homepage: https://mxlinux.org
